<?php

require_once ("tcpdf/tcpdf.php");

// ================================
// Print Active Users Subscriptions
// ================================

class Print_ActiveUserSubscriptions extends Base {

    // ==================
    // Class Constructor.
    // ==================

    public function __construct($output_type = "normal") {

        set_error_handler(array($this, "displayError"));

        date_default_timezone_set(self::TIMEZONE);
    }

    // ================
    // Print the Report
    // ================

    public function print($output_type = "normal") {

        $report = new ActiveUserSubscriptions();

        $report->output_type = $output_type;

        ob_clean();

        if ($output_type == "string") {
            return $report->render();
        } else {
            $report->render();
        }
    }
}

// ==========================
// Class to Generate the .pdf
// ==========================

class ActiveUserSubscriptions extends TCPDF {

    // Variables

    public $user_serial = 0;
    public $first_page = true;
    public $output_type = "normal";

    // ================
    // Debug an Object.
    // ================

    public function debug($object = "") {

        echo "<pre>";
        print_r($object);
        exit();
    }

    // =================
    // Render the Report
    // =================

    public function render() {

        set_time_limit(0);

        // Get the data for the report

        $users = (new Users())->getActiveUsers();

        // Set report defaults

        $this->title = "Active User Subscriptions";

        $this->SetFont("Calibri");
        $this->SetMargins(10, 25, 10);
        $this->SetHeaderMargin(10);
        $this->SetFooterMargin(10);
        $this->setCellPaddings(0, 0, 0, 0);
        $this->setCellMargins(2, 0, 0, 0);

        $this->addPage("P", "LETTER");

        // --------------------------
        // Active Users Subscriptions
        // --------------------------

        $this->SetFont("Calibri", "B", 10);

        foreach ($users as $user) {

            $user_serial = (integer) $user->user_serial;

            $subscriptions = (new Subscriptions())->getUsersActiveSubscriptions($user_serial);
            
            $this->SetFont("Calibri", "B", 10);
            $this->Cell(25, 0, "Name:", 0, 0, "L", false, "", 3);
            $this->SetFont("Calibri", "", 10);
            $this->Cell(80, 0, $user->user_client_name, 0, 0, "L", false, "", 3);
            $this->SetFont("Calibri", "B", 10);
            $this->Cell(25, 0, "Created:", 0, 0, "L", false, "", 3);
            $this->SetFont("Calibri", "", 10);
            $this->Cell(80, 0, $user->user_created_verbose, 0, 1, "L", false, "", 3);

            $this->SetFont("Calibri", "B", 10);
            $this->Cell(25, 0, "Main Email:", 0, 0, "L", false, "", 3);
            $this->SetFont("Calibri", "", 10);
            $this->Cell(80, 0, $user->user_email, 0, 0, "L", false, "", 3);
            $this->SetFont("Calibri", "B", 10);
            $this->Cell(25, 0, "Created By:", 0, 0, "L", false, "", 3);
            $this->SetFont("Calibri", "", 10);
            $this->Cell(80, 0, $user->user_creator, 0, 1, "L", false, "", 3);

            $this->SetFont("Calibri", "B", 10);
            $this->Cell(25, 0, "User Name:", 0, 0, "L", false, "", 3);
            $this->SetFont("Calibri", "", 10);
            $this->Cell(80, 0, $user->user_name, 0, 0, "L", false, "", 3);
            $this->SetFont("Calibri", "B", 10);
            $this->Cell(25, 0, "Changed", 0, 0, "L", false, "", 3);
            $this->SetFont("Calibri", "", 10);
            $this->Cell(80, 0, $user->user_changed_verbose, 0, 1, "L", false, "", 3);

            $this->SetFont("Calibri", "B", 10);
            $this->Cell(25, 0, "Roll:", 0, 0, "L", false, "", 3);
            $this->SetFont("Calibri", "", 10);
            $this->Cell(80, 0, $user->user_role, 0, 0, "L", false, "", 3);
            $this->SetFont("Calibri", "B", 10);
            $this->Cell(25, 0, "Changed By:", 0, 0, "L", false, "", 3);
            $this->SetFont("Calibri", "", 10);
            $this->Cell(80, 0, $user->user_changer, 0, 1, "L", false, "", 3);

            $this->SetFont("Calibri", "B", 10);
            $this->Cell(25, 0, "Change Password:", 0, 0, "L", false, "", 3);
            $this->SetFont("Calibri", "", 10);

            $user_change_password = ($user->user_change_password == 1) ? "Yes" : "No";

            $this->Cell(80, 0, $user_change_password, 0, 0, "L", false, "", 3);
            $this->SetFont("Calibri", "B", 10);
            $this->Cell(25, 0, "Last Login:", 0, 0, "L", false, "", 3);
            $this->SetFont("Calibri", "", 10);
            $this->Cell(80, 0, $user->user_login_verbose, 0, 1, "L", false, "", 3);

            $this->SetFont("Calibri", "B", 10);
            $this->Cell(25, 0, "", 0, 0, "L", false, "", 3);
            $this->SetFont("Calibri", "", 10);
            $this->Cell(80, 0, "", 0, 0, "L", false, "", 3);
            $this->SetFont("Calibri", "B", 10);
            $this->Cell(25, 0, "Active Status:", 0, 0, "L", false, "", 3);
            $this->SetFont("Calibri", "", 10);

            $user_active = ($user->user_active == 1) ? "Active" : "Inactive";
            $this->Cell(80, 0, $user_active, 0, 1, "L", false, "", 3);

            // ----------------------------------
            // Rectangle around the Users Details
            // ----------------------------------

            $this->RoundedRect(10, 23, 190, $this->GetY() - 21, 1.50, "1111");

            // -------------
            // Subscriptions
            // -------------
            $this->Ln(7);

            $this->SetFont("Calibri", "B", 12);
            $this->Cell(0, 0, "Subscriptions", 0, 1, "L", false, "", 3);
            $this->Ln(3);
            $this->SetFont("Calibri", "B", 10);

            $this->Cell(75, 0, "Description", "B", 0, "L", false, "", 3);
            $this->Cell(20, 0, "Start Date", "B", 0, "L", false, "", 3);
            $this->Cell(20, 0, "End Date", "B", 0, "L", false, "", 3);

            $this->SetFont("Calibri", "", 10);

            $this->Ln(6);

            if ($subscriptions->count() == 0) {

                $this->Cell(0, 0, "There are no Active Subscriptions...", 0, 1, "L", false, "", 3);
            } else {

                foreach ($subscriptions as $subscription) {

                    $this->Cell(75, 0, $subscription->subscription_full_title, 0, 0, "L", false, "", 3);
                    $this->Cell(20, 0, $subscription->usersubscription_start_date_verbose, 0, 0, "L", false, "", 3);
                    $this->Cell(20, 0, $subscription->usersubscription_end_date_verbose, 0, 0, "L", false, "", 3);

                    $this->Ln(4);

                    if ($this->GetY() > 265) {

                        $this->AddPage("P", "LETTER");

                        $this->SetFont("Calibri", "B", 10);

                        $this->Cell(75, 0, "Description", "B", 0, "L", false, "", 3);
                        $this->Cell(20, 0, "End Date", "B", 0, "L", false, "", 3);
                        $this->Cell(10, 0, "Status", "B", 0, "L", false, "", 3);

                        $this->SetFont("Calibri", "", 10);

                        $this->Ln(6);
                    }
                }
            }

            $this->addPage("P", "LETTER");
        }

        // --------------
        // Return the pdf
        // --------------

        if ($this->output_type == "string") {
            return $this->Output("ActiveUserSubscriptions.pdf", "S");
        } else {
            $this->Output("ActiveUserSubscriptions.pdf");
        }
    }

    // ======
    // Header
    // ======

    public function Header() {

        $this->setCellPaddings(0, 0, 0, 0);
        $this->setCellMargins(2, 0, 0, 0);

        $this->Image('images/dec-international-logo.png', 10, 7, 25, 10);

        $this->SetFont("Calibri", "B", 16);

        $this->Cell(0, 6, "Active Users Subscriptions", 0, 1, "C");

        $this->Ln(5);
    }

    // ======
    // Footer
    // ======

    public function Footer() {

        $this->SetFont("Calibri", "I", 8);

        $X = $this->GetX();

        $this->Cell(0, 10, "DEC-International, LLC", 0, false, "C");

        $this->SetX($X);

        $this->Cell(40, 10, "Page " . $this->getAliasNumPage() . "/" . $this->getAliasNbPages(), 0, false, "L");
        $this->Cell(0, 10, date("Y-m-d g:i A"), 0, false, "R");
    }

    // =======================
    // Stripe the printed line
    // =======================

    private function stripeLine($pRowCount = 0, $pRowWidth = 0) {

        $this->SetFillColor(($pRowCount % 2) ? 220 : 255);
        $X = $this->GetX();
        $this->Cell($pRowWidth, 0, "", 0, 0, "L", true);
        $this->SetX($X);
    }
}

?>
